Index: vm/device_pager.c
===================================================================
diff --git a/head/sys/vm/device_pager.c b/head/sys/vm/device_pager.c
--- a/head/sys/vm/device_pager.c	(revision 276659)
+++ b/head/sys/vm/device_pager.c	(working copy)
@@ -59,7 +59,7 @@
 static vm_object_t dev_pager_alloc(void *, vm_ooffset_t, vm_prot_t,
     vm_ooffset_t, struct ucred *);
 static void dev_pager_dealloc(vm_object_t);
-static int dev_pager_getpages(vm_object_t, vm_page_t *, int, int);
+static int dev_pager_getpages(vm_object_t, vm_page_t *, int, int, vm_prot_t);
 static void dev_pager_putpages(vm_object_t, vm_page_t *, int, 
 		boolean_t, int *);
 static boolean_t dev_pager_haspage(vm_object_t, vm_pindex_t, int *,
@@ -257,13 +257,14 @@
 }
 
 static int
-dev_pager_getpages(vm_object_t object, vm_page_t *ma, int count, int reqpage)
+dev_pager_getpages(vm_object_t object, vm_page_t *ma, int count, int reqpage,
+    vm_prot_t prot)
 {
 	int error, i;
 
 	VM_OBJECT_ASSERT_WLOCKED(object);
 	error = object->un_pager.devp.ops->cdev_pg_fault(object,
-	    IDX_TO_OFF(ma[reqpage]->pindex), PROT_READ, &ma[reqpage]);
+	    IDX_TO_OFF(ma[reqpage]->pindex), prot, &ma[reqpage]);
 
 	VM_OBJECT_ASSERT_WLOCKED(object);
 
Index: vm/phys_pager.c
===================================================================
diff --git a/head/sys/vm/phys_pager.c b/head/sys/vm/phys_pager.c
--- a/head/sys/vm/phys_pager.c	(revision 276659)
+++ b/head/sys/vm/phys_pager.c	(working copy)
@@ -137,7 +137,8 @@
  * Fill as many pages as vm_fault has allocated for us.
  */
 static int
-phys_pager_getpages(vm_object_t object, vm_page_t *m, int count, int reqpage)
+phys_pager_getpages(vm_object_t object, vm_page_t *m, int count, int reqpage,
+    vm_prot_t prot __unused)
 {
 	int i;
 
Index: vm/sg_pager.c
===================================================================
diff --git a/head/sys/vm/sg_pager.c b/head/sys/vm/sg_pager.c
--- a/head/sys/vm/sg_pager.c	(revision 276659)
+++ b/head/sys/vm/sg_pager.c	(working copy)
@@ -49,7 +49,7 @@
 static vm_object_t sg_pager_alloc(void *, vm_ooffset_t, vm_prot_t,
     vm_ooffset_t, struct ucred *);
 static void sg_pager_dealloc(vm_object_t);
-static int sg_pager_getpages(vm_object_t, vm_page_t *, int, int);
+static int sg_pager_getpages(vm_object_t, vm_page_t *, int, int, vm_prot_t);
 static void sg_pager_putpages(vm_object_t, vm_page_t *, int, 
 		boolean_t, int *);
 static boolean_t sg_pager_haspage(vm_object_t, vm_pindex_t, int *,
@@ -133,7 +133,8 @@
 }
 
 static int
-sg_pager_getpages(vm_object_t object, vm_page_t *m, int count, int reqpage)
+sg_pager_getpages(vm_object_t object, vm_page_t *m, int count, int reqpage,
+    vm_prot_t prot __unused)
 {
 	struct sglist *sg;
 	vm_page_t m_paddr, page;
Index: vm/swap_pager.c
===================================================================
diff --git a/head/sys/vm/swap_pager.c b/head/sys/vm/swap_pager.c
--- a/head/sys/vm/swap_pager.c	(revision 276659)
+++ b/head/sys/vm/swap_pager.c	(working copy)
@@ -360,8 +360,8 @@
 		swap_pager_alloc(void *handle, vm_ooffset_t size,
 		    vm_prot_t prot, vm_ooffset_t offset, struct ucred *);
 static void	swap_pager_dealloc(vm_object_t object);
-static int	swap_pager_getpages(vm_object_t, vm_page_t *, int, int);
-static int	swap_pager_getpages_async(vm_object_t, vm_page_t *, int, int,
+static int	swap_pager_getpages(vm_object_t, vm_page_t *, int, int, vm_prot_t);
+static int	swap_pager_getpages_async(vm_object_t, vm_page_t *, int, int, vm_prot_t,
     pgo_getpages_iodone_t, void *);
 static void	swap_pager_putpages(vm_object_t, vm_page_t *, int, boolean_t, int *);
 static boolean_t
@@ -614,7 +614,6 @@
 
 	pindex = OFF_TO_IDX(offset + PAGE_MASK + size);
 	if (handle) {
-		mtx_lock(&Giant);
 		/*
 		 * Reference existing named region or allocate new one.  There
 		 * should not be a race here against swp_pager_meta_build()
@@ -622,12 +621,13 @@
 		 * of the handle.
 		 */
 		sx_xlock(&sw_alloc_sx);
+		mtx_lock(&sw_alloc_mtx);
 		object = vm_pager_object_lookup(NOBJLIST(handle), handle);
+		mtx_unlock(&sw_alloc_mtx);
 		if (object == NULL) {
 			if (cred != NULL) {
 				if (!swap_reserve_by_cred(size, cred)) {
 					sx_xunlock(&sw_alloc_sx);
-					mtx_unlock(&Giant);
 					return (NULL);
 				}
 				crhold(cred);
@@ -643,7 +643,6 @@
 			VM_OBJECT_WUNLOCK(object);
 		}
 		sx_xunlock(&sw_alloc_sx);
-		mtx_unlock(&Giant);
 	} else {
 		if (cred != NULL) {
 			if (!swap_reserve_by_cred(size, cred))
@@ -1107,7 +1106,8 @@
  *	left busy, but the others adjusted.
  */
 static int
-swap_pager_getpages(vm_object_t object, vm_page_t *m, int count, int reqpage)
+swap_pager_getpages(vm_object_t object, vm_page_t *m, int count, int reqpage,
+    vm_prot_t prot __unused)
 {
 	struct buf *bp;
 	vm_page_t mreq;
@@ -1267,11 +1267,11 @@
  */
 static int
 swap_pager_getpages_async(vm_object_t object, vm_page_t *m, int count,
-    int reqpage, pgo_getpages_iodone_t iodone, void *arg)
+    int reqpage, vm_prot_t prot, pgo_getpages_iodone_t iodone, void *arg)
 {
 	int r, error;
 
-	r = swap_pager_getpages(object, m, count, reqpage);
+	r = swap_pager_getpages(object, m, count, reqpage, prot);
 	VM_OBJECT_WUNLOCK(object);
 	switch (r) {
 	case VM_PAGER_OK:
@@ -1770,7 +1770,7 @@
 		return;
 	}
 
-	if (swap_pager_getpages(object, &m, 1, 0) != VM_PAGER_OK)
+	if (swap_pager_getpages(object, &m, 1, 0, VM_PROT_ALL) != VM_PAGER_OK)
 		panic("swap_pager_force_pagein: read from swap failed");/*XXX*/
 	vm_object_pip_wakeup(object);
 	vm_page_dirty(m);
Index: vm/vm_fault.c
===================================================================
diff --git a/head/sys/vm/vm_fault.c b/head/sys/vm/vm_fault.c
--- a/head/sys/vm/vm_fault.c	(revision 276659)
+++ b/head/sys/vm/vm_fault.c	(working copy)
@@ -658,7 +658,7 @@
 
 			rv = faultcount ?
 			    vm_pager_get_pages(fs.object, marray, faultcount,
-				reqpage) : VM_PAGER_FAIL;
+				reqpage, prot) : VM_PAGER_FAIL;
 
 			if (rv == VM_PAGER_OK) {
 				/*
Index: vm/vm_glue.c
===================================================================
diff --git a/head/sys/vm/vm_glue.c b/head/sys/vm/vm_glue.c
--- a/head/sys/vm/vm_glue.c	(revision 276659)
+++ b/head/sys/vm/vm_glue.c	(working copy)
@@ -239,7 +239,7 @@
 	m = vm_page_grab(object, pindex, VM_ALLOC_NORMAL);
 	if (m->valid != VM_PAGE_BITS_ALL) {
 		ma[0] = m;
-		rv = vm_pager_get_pages(object, ma, 1, 0);
+		rv = vm_pager_get_pages(object, ma, 1, 0, VM_PROT_ALL);
 		m = vm_page_lookup(object, pindex);
 		if (m == NULL)
 			goto out;
@@ -589,7 +589,8 @@
 				if (ma[j]->valid == VM_PAGE_BITS_ALL)
 					break;
 			}
-			rv = vm_pager_get_pages(ksobj, ma + i, j - i, 0);
+			rv = vm_pager_get_pages(ksobj, ma + i, j - i, 0,
+			    VM_PROT_ALL);
 			if (rv != VM_PAGER_OK)
 	panic("vm_thread_swapin: cannot get kstack for proc: %d",
 				    td->td_proc->p_pid);
Index: vm/vm_object.c
===================================================================
diff --git a/head/sys/vm/vm_object.c b/head/sys/vm/vm_object.c
--- a/head/sys/vm/vm_object.c	(revision 276659)
+++ b/head/sys/vm/vm_object.c	(working copy)
@@ -2052,7 +2052,7 @@
 		m = vm_page_grab(object, pindex, VM_ALLOC_NORMAL);
 		if (m->valid != VM_PAGE_BITS_ALL) {
 			ma[0] = m;
-			rv = vm_pager_get_pages(object, ma, 1, 0);
+			rv = vm_pager_get_pages(object, ma, 1, 0, VM_PROT_ALL);
 			m = vm_page_lookup(object, pindex);
 			if (m == NULL)
 				break;
Index: vm/vm_pager.c
===================================================================
diff --git a/head/sys/vm/vm_pager.c b/head/sys/vm/vm_pager.c
--- a/head/sys/vm/vm_pager.c	(revision 276659)
+++ b/head/sys/vm/vm_pager.c	(working copy)
@@ -86,7 +86,7 @@
 
 int cluster_pbuf_freecnt = -1;	/* unlimited to begin with */
 
-static int dead_pager_getpages(vm_object_t, vm_page_t *, int, int);
+static int dead_pager_getpages(vm_object_t, vm_page_t *, int, int, vm_prot_t);
 static vm_object_t dead_pager_alloc(void *, vm_ooffset_t, vm_prot_t,
     vm_ooffset_t, struct ucred *);
 static void dead_pager_putpages(vm_object_t, vm_page_t *, int, int, int *);
@@ -94,13 +94,11 @@
 static void dead_pager_dealloc(vm_object_t);
 
 static int
-dead_pager_getpages(obj, ma, count, req)
-	vm_object_t obj;
-	vm_page_t *ma;
-	int count;
-	int req;
+dead_pager_getpages(vm_object_t obj, vm_page_t *ma, int count, int req,
+    vm_prot_t prot)
 {
-	return VM_PAGER_FAIL;
+
+	return (VM_PAGER_FAIL);
 }
 
 static vm_object_t
Index: vm/vm_pager.h
===================================================================
diff --git a/head/sys/vm/vm_pager.h b/head/sys/vm/vm_pager.h
--- a/head/sys/vm/vm_pager.h	(revision 276659)
+++ b/head/sys/vm/vm_pager.h	(working copy)
@@ -50,9 +50,9 @@
 typedef vm_object_t pgo_alloc_t(void *, vm_ooffset_t, vm_prot_t, vm_ooffset_t,
     struct ucred *);
 typedef void pgo_dealloc_t(vm_object_t);
-typedef int pgo_getpages_t(vm_object_t, vm_page_t *, int, int);
+typedef int pgo_getpages_t(vm_object_t, vm_page_t *, int, int, vm_prot_t);
 typedef void pgo_getpages_iodone_t(void *, vm_page_t *, int, int);
-typedef int pgo_getpages_async_t(vm_object_t, vm_page_t *, int, int,
+typedef int pgo_getpages_async_t(vm_object_t, vm_page_t *, int, int, vm_prot_t,
     pgo_getpages_iodone_t, void *);
 typedef void pgo_putpages_t(vm_object_t, vm_page_t *, int, int, int *);
 typedef boolean_t pgo_haspage_t(vm_object_t, vm_pindex_t, int *, int *);
@@ -106,9 +106,9 @@
     vm_ooffset_t, struct ucred *);
 void vm_pager_bufferinit(void);
 void vm_pager_deallocate(vm_object_t);
-static __inline int vm_pager_get_pages(vm_object_t, vm_page_t *, int, int);
+static __inline int vm_pager_get_pages(vm_object_t, vm_page_t *, int, int, vm_prot_t prot);
 static inline int vm_pager_get_pages_async(vm_object_t, vm_page_t *, int,
-    int, pgo_getpages_iodone_t, void *);
+    int, vm_prot_t prot, pgo_getpages_iodone_t, void *);
 static __inline boolean_t vm_pager_has_page(vm_object_t, vm_pindex_t, int *, int *);
 void vm_pager_init(void);
 vm_object_t vm_pager_object_lookup(struct pagerlst *, void *);
@@ -127,12 +127,14 @@
 	vm_object_t object,
 	vm_page_t *m,
 	int count,
-	int reqpage
+	int reqpage,
+	vm_prot_t prot
 ) {
 	int r;
 
 	VM_OBJECT_ASSERT_WLOCKED(object);
-	r = (*pagertab[object->type]->pgo_getpages)(object, m, count, reqpage);
+	r = (*pagertab[object->type]->pgo_getpages)(object, m, count,
+	    reqpage, prot);
 	if (r == VM_PAGER_OK && m[reqpage]->valid != VM_PAGE_BITS_ALL) {
 		vm_page_zero_invalid(m[reqpage], TRUE);
 	}
@@ -141,12 +143,12 @@
 
 static inline int
 vm_pager_get_pages_async(vm_object_t object, vm_page_t *m, int count,
-    int reqpage, pgo_getpages_iodone_t iodone, void *arg)
+    int reqpage, vm_prot_t prot, pgo_getpages_iodone_t iodone, void *arg)
 {
 
 	VM_OBJECT_ASSERT_WLOCKED(object);
 	return ((*pagertab[object->type]->pgo_getpages_async)(object, m,
-	    count, reqpage, iodone, arg));
+	    count, reqpage, prot, iodone, arg));
 }
 
 static __inline void
Index: vm/vnode_pager.c
===================================================================
diff --git a/head/sys/vm/vnode_pager.c b/head/sys/vm/vnode_pager.c
--- a/head/sys/vm/vnode_pager.c	(revision 276659)
+++ b/head/sys/vm/vnode_pager.c	(working copy)
@@ -84,8 +84,8 @@
 static void vnode_pager_dealloc(vm_object_t);
 static int vnode_pager_local_getpages0(struct vnode *, vm_page_t *, int, int,
     vop_getpages_iodone_t, void *);
-static int vnode_pager_getpages(vm_object_t, vm_page_t *, int, int);
-static int vnode_pager_getpages_async(vm_object_t, vm_page_t *, int, int,
+static int vnode_pager_getpages(vm_object_t, vm_page_t *, int, int, vm_prot_t);
+static int vnode_pager_getpages_async(vm_object_t, vm_page_t *, int, int, vm_prot_t,
     vop_getpages_iodone_t, void *);
 static void vnode_pager_putpages(vm_object_t, vm_page_t *, int, int, int *);
 static boolean_t vnode_pager_haspage(vm_object_t, vm_pindex_t, int *, int *);
@@ -656,7 +656,8 @@
  * backing vp's VOP_GETPAGES.
  */
 static int
-vnode_pager_getpages(vm_object_t object, vm_page_t *m, int count, int reqpage)
+vnode_pager_getpages(vm_object_t object, vm_page_t *m, int count, int reqpage,
+    vm_prot_t prot __unused)
 {
 	int rtval;
 	struct vnode *vp;
@@ -673,7 +674,7 @@
 
 static int
 vnode_pager_getpages_async(vm_object_t object, vm_page_t *m, int count,
-    int reqpage, vop_getpages_iodone_t iodone, void *arg)
+    int reqpage, vm_prot_t prot, vop_getpages_iodone_t iodone, void *arg)
 {
 	struct vnode *vp;
 	int rtval;
